Part 2DVersatz

From FreeCAD Documentation
Revision as of 16:25, 2 December 2019 by Maker (talk | contribs) (Created page with "* {{PropertyData /de|Modus}} ("Pipe" oder "Skin"): Legt fest, wie nicht geschlosseneDrähte verarbeitet werden. Bei "Pipe" wird der Draht so umrissen, als wäre er eine extrem...")

Part Offset2D

Menu location
Part → 2D Offset
Workbenches
Part
Default shortcut
None
Introduced in version
0.17
See also
Part Offset 3D, Part Thickness, Draft Offset

Beschreibung==

Teil 2D Versatz konstruiert einen Draht, parallel zum ursprünglichen Draht, in einem bestimmten Abstand von diesem. Oder vergrößert/schrumpft gleichzeitig eine ebene Fläche.

Der Draht/Fläche muss plan sein. Es kann mehrere Drähte in einem Objekt geben, nicht unbedingt koplanar.

Anwendung

  1. Wähle ein Objekt aus, zum versetzen aus.
  2. Drücke die Taste Offset2D Taste.
  3. Richte den Versatz im Aufgabenbereich ein.
  4. Drücke OK.

Ein parametrisches 2D Offset Objekt wird erstellt. Originalobjekte werden in den Drahtmodell Anzeigemodus geschaltet.

Eigenschaften

  • Daten-EigenschaftQuelle: Verbindung zur Originalform
  • {{PropertyData/de|Wert} Der Abstand, um den Draht/Fläche zu vergrößern um. Im negativen Fall wird stattdessen die Draht/Fläche geschrumpft.
  • Template:PropertyData /de ("Pipe" oder "Skin"): Legt fest, wie nicht geschlosseneDrähte verarbeitet werden. Bei "Pipe" wird der Draht so umrissen, als wäre er eine extrem dünne, geschlossene Kontur. Wenn "Skin", wird ein offener Draht erzeugt.
  • DatenJoin ("Arc", "Tangent", "Intersection"): sets the behavior around kinks. If "Arc", offset segments are connected with an arc of circle, centered at the vertex. "Tangent" is unsupported on OCC7.0.0. "Intersection": offset segments are extended till they intersect.
  • DatenIntersection ("false", "true"): sets if multiple wires are treated collectively or independently. If "false", wires are offset independently, intersections between resulting wires are ignored. If "true", the wires are offset in collective manner.
Only wires within a compound are coupled. For example, if the structure is like compound(wire1, wire2, compound(wire3, wire4)), wire1 and wire2 will be treated collectively, but independently from wire3 and wire4. Likewise, wire3 and wire4 are treated collectively, but independently of wire1+wire2.
Also, in collective mode, directions of wires are important, and influence direction of offset. This is in tight relationship with how holes in faces are treated.
Wires being treated collectively must be coplanar. Wires being offset independently don't have to be coplanar.
  • DatenFill ("false", "true"): if "true", the space between original wire/face and the offset is filled with a face.

Known issues

  • Most of non-default modes will only work with OCC 7.0.0 or later.
  • Using the tool can crash FreeCAD (see next point). On Windows, these crashes are converted to exceptions and don't generally cause FreeCAD to close; on other OS'es it is not the case. So, it is advised to save project before attempting to use the tool.
  • Enlarging faces with circular holes by an amount large enough to cause holes to close up, a crash occurs (OCC 7.0.0). The problem seems to be specific to circles; other shapes seem to close out properly.
  • when offsetting circles that have non-zero Placement, the result is placed wrongly. (OCC 7.0.0)
  • when offsetting circles, sometimes they are offset in unexpected direction (e.g. inward instead of outward). (OCC 7.0.0)
  • Fill="true" doesn't work when collectively offsetting open wires in "Skin" mode
  • "Tangent" join mode doesn't work (OCC 7.0.0)
  • Offsetting wires made of single line segment is not supported (because line segment doesn't define a plane). Single line segments cannot participate in collective offset either.

Scripting

The tool can by used in macros and from the python console by using the following function:

f = App.ActiveDocument.addObject("Part::Offset2D", "Offset2D")
f.Source =  #some object
f.Value = 10.0

2D offset is also available as a method of Part.Shape. Example:

import Part
circle = Part.Circle().toShape()
enlarged_circle = circle.makeOffset2D(10.0)
Part.show(circle)
Part.show(enlarged_circle)
# makeOffset2D(offset, join = 0, fill = False, openResult = false, intersection = false)
# 
# * offset: distance to expand the shape by. 
# 
# * join: method of offsetting non-tangent joints. 0 = arcs, 1 = tangent, 2 =
# intersection
# 
# * fill: if true, the output is a face filling the space covered by offset. If
# false, the output is a wire/face.
# 
# * openResult: True for "Skin" mode; False for Pipe mode. 
# 
# * intersection: collective offset
# 
# Returns: result of offsetting (wire or face or compound of those). Compounding
# structure follows that of source shape.